Unit DE60R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE14_p;

procedure DE60R(var CK :Array of Real; var CG :Array of Real;
                var CR :Array of Real; NX :Integer;
                var X :Array of Real; GN1 :Boolean;
                var GN :Array of Real; GK1 :Boolean;
                var GK :Array of Real; var Y :Array of Real;
                var ALP :Array of Extended; var BET :Array of Extended;
                var IERR :Integer);

implementation

procedure DE60R(var CK :Array of Real; var CG :Array of Real;
                var CR :Array of Real; NX :Integer;
                var X :Array of Real; GN1 :Boolean;
                var GN :Array of Real; GK1 :Boolean;
                var GK :Array of Real; var Y :Array of Real;
                var ALP :Array of Extended; var BET :Array of Extended;
                var IERR :Integer);
var
I,J,NXM1 :Integer;
H1,HP,RA,RA2,H,YDP :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
IERR := 0;
if ( GN1 ) 
 then goto _1;
if ( GN[0] >= 0.0 ) 
 then goto _1;
IERR := 65;
goto _15;
_1:
if ( GK1 ) 
 then goto _2;
if ( GK[0] >= 0.0 ) 
 then goto _2;
IERR := 66;
goto _15;
_2:
if ( NX > 1 ) 
 then goto _3;
IERR := 69;
goto _15;
_3:
NXM1 := NX-1;
H1 := X[1]-X[0];
if ( H1 <= 0.e0 ) 
 then goto _14;
if ( CK[0] <= 0.0 ) 
 then goto _12;
if ( GN1 ) 
 then goto _4;
HP := 0.5e0*H1;
RA := CK[0]/H1;
if ( CG[0] < 0.0 ) 
 then goto _13;
RA2 := RA+GN[0]+HP*CG[0];
ALP[0] := RA/RA2;
BET[0] := (HP*CR[0]+GN[1])/RA2;
goto _5;
_4:
ALP[0] := 0.0;
BET[0] := GN[0];
_5:
if ( NX = 2 ) 
 then goto _7;
J := 0;
for I:=2 to NXM1 do
 begin
  J := J+2;
  H := H1;
  HP := H*0.5e0;
  H1 := X[I+0]-X[I-1];
  if ( H1 <= 0.e0 ) 
   then goto _14;
  if ( CK[I-1] <= 0.0 ) 
   then goto _12;
  RA := CK[I-1]*H/H1;
  if ( CG[J-1] < 0.0 ) or ( CG[J+0] < 0.0 ) 
   then goto _13;
  RA2 := CK[I-2]+RA+HP*(H*CG[J-1]+H1*CG[J+0])-ALP[I-2]*CK[I-
    1-1];
  RA2 := 1.e0/RA2;
  ALP[I-1] := RA*RA2;
  BET[I-1] := CK[I-2]*BET[I-2]*RA2+HP*(H*CR[J-1]+H1*CR[J+0])*
    RA2;
_6:
 end;
_7:
if ( GK1 ) 
 then goto _8;
RA := CK[NXM1-1]/H1;
HP := 0.5e0*H1;
if ( CG[J+1] < 0.0 ) 
 then goto _13;
RA2 := RA+GK[0]+HP*CG[J+1];
RA := RA/RA2;
RA2 := (HP*CR[J+1]+GK[1])/RA2;
goto _9;
_8:
Y[NX-1] := GK[0];
YDP := GK[0];
goto _10;
_9:
YDP := (RA2+RA*BET[NXM1-1])/(1.e0-ALP[NXM1-1]*RA);
Y[NX-1] := YDP;
_10:
for I:=1 to NXM1 do
 begin
  J := NX-I;
  YDP := ALP[J-1]*YDP+BET[J-1];
  Y[J-1] := YDP;
_11:
 end;
goto _15;
_12:
IERR := 67;
goto _15;
_13:
IERR := 68;
goto _15;
_14:
IERR := 70;
_15:
if ( IERR <> 0 ) 
 then UTDE14(IERR,60);
end;

end.
